Package com.emc.d2fs.interfaces

# Interface IDialogService

public interface IDialogService
D2 dialog services.

Note that Attribute lists are used to provide common and dialog specific arguments and object attributes when building and submitting dialogs. See `D2fsConstants` for additional dialog names.

Common Dialog Attributes:
  - mode: DF_STRING - Desired Dialog Mode {"create", "edit", "import"}
  - id: DF_ID - Id of the target object; Defaults to Context's id
  - r_object_type: DF_STRING - Documentum object type
  - confirm: DF_BOOLEAN - Indicate that the operation is confirmed. If an operation requires confirmation, this must be true or a D2ConfirmException() will be returned.
  - Type specific attribute name: VARIOUS - Documentum object specific attributes. ie. "object_name"

PropertiesDialog -- `D2fsConstants.PROPERTIES`
  - r_object_type: DF_STRING - Documentum object type (for creation)
  - count_import_file: DF_INTEGER - Number of files being imported
  - property_config: DF_STRING - Name of property configuration
  - force_dialog: DF_STRING - Force a specific dialog name
  - force_readonly: DF_BOOLEAN - Boolean to force dialog to be readonly
  - o2_config: DF_STRING - O2 configuration name
  - default_value: DF_STRING - Name of default value configuration name
  - list: DF_STRING - List of attribute names that will get default values (separated by AttributeUtils.SEPARATOR_VALUE)
  - inheritedId: DF_ID - ID of object from which to inherit
  - inheritance_properties: DF_BOOLEAN- Control if property inheritance is active
  - inheritance_content: DF_BOOLEAN- Control if content is inherited
  - attr_inheritance: DF_STRING - Name of the attribute inheritance configuration

CreateDialog -- `D2fsConstants.CREATE`
  - file_name: DF_STRING - Filename added to label
  - inheritedId: DF_STRING - ID of object from which to inherit

ImportAttachmentDialog -- `D2fsConstants.IMPORT_ATTACHMENT`
  - attachment_names: (OUTPUT?) DF_STRING- List of filenames

AdvancedSearchDialog -- `D2fsConstants.ADVANCED_SEARCH`
  - id: DF_ID - Id of search or {"node_last_search" for last search}
  - mode: DF_STRING - Mode {"creation | "modification"}

SaveSearchDialog -- `D2fsConstants.SAVE_SEARCH`
  - search_name: DF_STRING - Name of saved search.

CommentDialog -- `D2fsConstants.COMMENT`
  - id: DF_ID - Id of the object being commented on
  - editor: DF_STRING - Richtext body of the comment
  - parentCommentId: DF_STRING - Id of the parent comment (if any)

D2WorkflowLaunchDialog -- `D2fsConstants.D2WORKFLOW_LAUNCH`
  - config: DF_STRING - Name of the D2 workflow config

TaskDelegateWfManagerDialog
  - workflowTrackerId: DF_ID - Id of the workflow tracker
  - contextType: DF_STRING - Task/activity name

TaskDialog -- `D2fsConstants.TASK`
  - operation: DF_STRING - The task operation {"forward", "reject", ???OTHERS}

TaskPerformerDialog
  - workflowTrackerId: DF_ID - Id of the workflow tracker

TaskPropertyPageDialog -- `D2fsConstants.TASK_PROPERTY`
  - property_page: DF_STRING - Name of the property configuration.
  - dialog_title_prefix: DF_STRING - Name added to beginning of dialog label

DestroyDialog -- `D2fsConstants.DESTROY`
  - okForAll: DF_STRING - Include "buttonOkForAll" button if "true"

AdminDictionaryDialog -- `D2fsConstants.ADMIN_DICTIONARY`
  - gridLocales: DF_STRING - List of locales (separated by AttributeUtils.SEPARATOR_VALUE)
  - gridAlias: DF_STRING - List of alias values (separated by AttributeUtils.SEPARATOR_VALUE)
  - gridLocalesRemove: DF_STRING - locales to remove
  - gridAliasRemove: DF_STRING - locales aliases to remove

ExportDictionaryDialog -- `D2fsConstants.EXPORT_DICTIONARY`
  - value_number: DF_STRING - A value for default value number.
  - IsABigDictionary: DF_BOOLEAN - Adjust height for larger dictionaries.

LoadVersionDictionaryDialog -- `D2fsConstants.LOAD_VERSION_DICTIONARY`
  - object_name: DF_STRING - Dictionary Name

SaveVersionDictionaryDialog -- `D2fsConstants.SAVE_VERSION_DICTIONARY`
  - object_name: DF_STRING - Dictionary Name

DistributionDialog -- `D2fsConstants.DISTRIBUTION_DIALOG`
  - config_name: DF_STRING - Name of distribution config (overridden by tracker config name)

ChangeStateDialog -- `D2fsConstants.CHANGE_STATE`
  - dialog_lifecycle: DF_STRING - Property configuration name

MassUpdateDialog -- `D2fsConstants.MASS_UPDATE_DIALOG`
  - config_name: DF_STRING - Mass update configuration name

ChangePermissionsDialog -- `D2fsConstants.CHANGE_PERMISSIONS`
  - config_name: DF_STRING - Name of Acl configuration name

PreferencesDialog -- `D2fsConstants.PREFERENCES`
  - FORCED_LANGUAGE: DF_BOOLEAN - Set forced language to be active.

DmGroupDialog -- `D2fsConstants.DM_GROUP_DIALOG`
  - mode: DF_STRING - Determine if create or other mode {"create", "edit"}.

DmUserDialog -- `D2fsConstants.DM_USER_DIALOG`
  - mode: DF_STRING - Determine if create or other mode {"create", "edit"}.

RelationCreateDialog -- `D2fsConstants.DM_USER_DIALOG`

  (for use in validDialog()) - -

  - description: DF_STRING - Description of new relation
  - relation_type: DF_STRING - Name of the relation type.
  - relation_target: DF_BOOLEAN - Reverse the relationship.
  - relation_target: DF_STRING - Id of the relation child.

QueryCategoryDialog -- `D2fsConstants.QUERY_CATEGORY`
  - is_public: DF_BOOLEAN - The default value for is_public

SendmailDialog -- `D2fsConstants.SENDMAIL`
  - locate_url: DF_STRING - List of URLs to include in message body (separated by AttributeUtils.SEPARATOR_VALUE)

    (for validDialog)

  - address: DF_STRING - List of recipients (separated by AttributeUtils.SEPARATOR_VALUE)
  - message: DF_STRING - Message body.
  - subject: DF_STRING - Message subject.
  - attach: DF_BOOLEAN - Determine if attachments are added.
  - format: DF_STRING - Preferred format

SignOffDialog -- `D2fsConstants.SIGN_OFF`
  - intention_assistance_type: DF_STRING - Assistance type
  - intention_assistance_value: DF_STRING - Assistance value
  - intention_assistance_locale: DF_STRING - Assistance local (default "auto")
  - intention_required: DF_BOOLEAN - Determine if intention is required.
  - intention_editable: DF_BOOLEAN - Determine if intention is editable

ContentSubscriptionDialog -- `D2fsConstants.CONTENT_SUBSCRIPTION`

  (for validDialog)

  - subscriptions: DF_STRING - List of subscription configuration names for each subscription (separated by AttributeUtils.SEPARATOR_VALUE)

ExportTaxonomyDialog -- `D2fsConstants.EXPORT_TAXONOMY`
  - value_number: DF_STRING - A value for default value number.
  - IsABigTaxonomy: DF_BOOLEAN - Adjust height of dialog for large taxonomy.

LoadVersionTaxonomyDialog -- `D2fsConstants.LOAD_VERSION_TAXONOMY`
  - object_name: DF_STRING - Taxonomy name

SaveVersionTaxonomyDialog -- `D2fsConstants.SAVE_VERSION_TAXONOMY`
  - object_name: DF_STRING - Taxonomy name

VDSnapshotCreateDialog -- `D2fsConstants.VD_SNAPSHOT_CREATE_DIALOG`

  (for validDialog)

  - title: DF_STRING - Title of snapshot

VdTemplateDialog -- `D2fsConstants.VD_INHERITED_TEMPLATES`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Dialog`
  `cancelDialog(Context context, String id, String dialogName, List<Attribute> parameters)`
  Cancel dialog
  `Dialog`
  `getDialog(Context context, String id, String dialogName, List<Attribute> parameters)`
  Get dialog object to display
  `String`
  `getExportValuesUrl(Context context, String format, String separator)`
  Get export values url
  `String`
  `getImportValuesUrl(Context context, String separator)`
  Get import values url
  `Dialog`
  `getLabels(Context context, List<Attribute> parameters)`
  Get label values
  `Dialog`
  `getOptions(Context context, List<Attribute> parameters)`
  Get options for combo box field
  `List<SubformInfo>`
  `getSubforms(Context context, String id, String dialogName, List<Attribute> parameters)`
  doc here
  `Dialog`
  `getTaxonomy(Context context, List<Attribute> parameters)`
  Get taxonomy values for combo box field
  `boolean`
  `isMemberOfGroup(Context context, List<Attribute> attributes)`
  Check if user is member of a group
  `void`
  `setBaseUrl(String url)`
  Set server base url used to build the url for `getExportValuesUrl` or `getImportValuesUrl` Since 4.2.1 for `getDialog` or `validDialog` or `cancelDialog`
  `Dialog`
  `validDialog(Context context, String id, String dialogName, List<Attribute> parameters)`
  Valid dialog submission

- ## Method Details

  - ### getDialog

    Dialog getDialog(Context context, String id, String dialogName, List<Attribute> parameters) throws Exception
    Get dialog object to display
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of related document id
      `dialogName` - String dialog name -- See `D2fsConstants` for values labeled "Dialog name".
      `parameters` - `Attribute` list of additional parameters.

      Attributes: "mode" = {"create", "edit", "import"} -- Dialog use mode

    Returns:
      `Dialog` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### validDialog

    Dialog validDialog(Context context, String id, String dialogName, List<Attribute> parameters) throws Exception
    Valid dialog submission
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of related document id
      `dialogName` - String dialog name -- See values labeled "Dialog name" in `D2fsConstants`.
      `parameters` - `Attribute` list of additional parameters. `getDialog(com.emc.d2fs.models.context.Context, java.lang.String, java.lang.String, java.util.List<com.emc.d2fs.models.attribute.Attribute>)` for attribute details.
    Returns:
      `Dialog` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### cancelDialog

    Dialog cancelDialog(Context context, String id, String dialogName, List<Attribute> parameters) throws Exception
    Cancel dialog
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of related document id
      `dialogName` - String dialog name -- See values labeled "Dialog name" `D2fsConstants`
      `parameters` - `Attribute` list of additional parameters
    Returns:
      `Dialog` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getOptions

    Dialog getOptions(Context context, List<Attribute> parameters) throws Exception
    Get options for combo box field
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parameters` - `Attribute` list of additional parameters
    Returns:
      `Dialog` object containing xml content as options
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getTaxonomy

    Dialog getTaxonomy(Context context, List<Attribute> parameters) throws Exception
    Get taxonomy values for combo box field
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parameters` - `Attribute` list of additional parameters
    Returns:
      `Dialog` object containing xml content as taxonomy values
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getLabels

    Dialog getLabels(Context context, List<Attribute> parameters) throws Exception
    Get label values
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parameters` - `Attribute` list of additional parameters
    Returns:
      `Dialog` object containing xml content as labels
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### isMemberOfGroup

    boolean isMemberOfGroup(Context context, List<Attribute> attributes) throws Exception
    Check if user is member of a group
    Parameters:
      `context` - `Context` object containing informations about client/session
      `attributes` - `Attribute` list of additional parameters as targeted group name
    Returns:
      true if user is a member
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### setBaseUrl

    void setBaseUrl(String url)
    Set server base url used to build the url for `getExportValuesUrl` or `getImportValuesUrl` Since 4.2.1 for `getDialog` or `validDialog` or `cancelDialog`
    Parameters:
      `url` - String value of base url
    Since:
      4.1.0

  - ### getExportValuesUrl

    String getExportValuesUrl(Context context, String format, String separator) throws Exception
    Get export values url
    Parameters:
      `context` - `Context` object containing informations about client/session
      `format` - String value of dictionary format
      `separator` - String value of data separator value
    Returns:
      String value of export url
    Throws:
      `D2fsException`
      `Exception`
    Since:
      4.1.0

  - ### getImportValuesUrl

    String getImportValuesUrl(Context context, String separator) throws Exception
    Get import values url
    Parameters:
      `context` - `Context` object containing informations about client/session
      `separator` - String value of data separator value
    Returns:
      String value of import url
    Throws:
      `D2fsException`
      `Exception`
    Since:
      4.1.0

  - ### getSubforms

    List<SubformInfo> getSubforms(Context context, String id, String dialogName, List<Attribute> parameters) throws Exception
    doc here
    Throws:
      `Exception`